/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 6.583810665079091e-07,6.458050664376449e-07,6.45747862695993e-07,6.458083677325721e-07 };
    static double noise_model_B[] = { -8.368472306483928e-07,-8.553685926555313e-07,-5.46455588665976e-07,-3.4847058501334723e-07 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 1.183684702421326e-12,9.865073334310712e-13,1.01849387048785e-12,1.4373690621265084e-12 };
    static double noise_model_D[] = { 3.3587313661344455e-07,3.0681018551524126e-07,2.929153768130966e-07,3.1392338228137734e-07 };
    double digital_gain = (sens / 3200.0) < 1.0 ? 1.0 : (sens / 3200.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
