/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 2.515988220475009e-06,2.5740242457162117e-06,2.564943020792984e-06,2.526371765378798e-06 };
    static double noise_model_B[] = { 1.543092391609118e-05,2.6539817610415882e-05,2.715530713888302e-05,2.223070504374768e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 3.087738991561554e-11,3.3510010701210584e-11,3.4661475461881955e-11,3.2253320501174744e-11 };
    static double noise_model_D[] = { 3.049455157537867e-07,-1.0312139756732006e-07,-1.3343993285968394e-07,1.5154733340051788e-07 };
    double digital_gain = (sens / 400.0) < 1.0 ? 1.0 : (sens / 400.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
